/*
 * Java application using Oracle "thin" driver
 * Net8/SQL*Net not required on client
 *
 * @version 1.01 04/01/2000
 * @author  John Jay King
 */

import java.sql.*;	// needed for JDBC

/** Sample use of Oracle "thin" JDBC connection */
public class OraThinJDBC
{
  public static void main (String args [])
       throws SQLException
  {
    // Load the Oracle JDBC driver
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

    // Connect to the database, connection string format: 
    // 	jdbc:oracle:thin:@**hostcomputer**:**port**:**oraclesid**
    Connection conn =
      DriverManager.getConnection ("jdbc:oracle:thin:@tecra:1521:tec817",
				   "scott", "tiger");

    // Create a Statement
    Statement stmt = conn.createStatement ();

    // Select the ENAME and JOB columns from the EMP table
    ResultSet rset = stmt.executeQuery ("select ename,job from emp");

    // Loop through results set and print the employee info
    while (rset.next ())
      System.out.println ("Employee: " + rset.getString (1)
                        + " is a " + rset.getString(2));
   // Close statement
	 stmt.close();
	 // Close connection
	 conn.close();
  } // end main
} // end OraThinJDBC