/*
 * Java application using Oracle "thin" driver
 * Net8/SQL*Net not required on client
 *
 * Program creates report using JDBC query
 *
 * @version 1.01 05/10/2001
 * @author  John Jay King
 */

import java.sql.*;	// needed for JDBC
import java.text.*;
/** Sample use of Oracle "thin" JDBC connection */
public class OraThinOrders
{
  public static void main (String args [])
       throws SQLException
  {
    // Load the Oracle JDBC driver
    DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

    // Connect to the database, connection string format:
    // 	jdbc:oracle:thin:@**hostcomputer**:**port**:**oraclesid**
    Connection conn =
      DriverManager.getConnection ("jdbc:oracle:thin:@tecra:1521:tec817",
				   "scott", "tiger");

    // Create a Statement
    Statement stmt = conn.createStatement ();

	String mySQL = "select sales.custid "
	               + "       ,state "
	               + "       ,amount "
	               + "       ,prodname "
	               + "     from sales "
	               + "         ,customer "
	               + "     where prodname like 'ACE TENNIS BALLS%' "
	               + "       and sales.custid = customer.custid "
	               + "     order by state "
	               + "             ,amount ";
	DecimalFormat  decFormat = new DecimalFormat("##,##0.00");
	double inAmount = 0;
	double totAmount = 0;
    // Select columns
    ResultSet rset = stmt.executeQuery (mySQL);
	printColumnHeadings();
    // Loop through results set and print the employee info
    while (rset.next ()) {
      inAmount = rset.getDouble("AMOUNT");
      totAmount = totAmount + inAmount;
      System.out.println (rset.getString("STATE")
      					+ "\t" + rset.getInt("CUSTID")
      					+ "\t" + rset.getString("PRODNAME")
      					+ "\t" + decFormat.format(inAmount)
      					) ;
	} // end while
	System.out.println();
	System.out.println("Total Sales\t\t\t\t" + decFormat.format(totAmount) + "\n");
   // Close statement
	 stmt.close();
	 // Close connection
	 conn.close();
  } // end main
  public static void printColumnHeadings() {
	  System.out.println("State\tCustID\tProduct Name\t\tPurchases");
	  System.out.println();
  } // end printColumnheadings
} // end OraThinJDBC