import java.awt.*;
import java.sql.*;
import java.awt.event.*;
import java.text.*;
/** Sample Solution - Programming GUI Events (JDBC)
 *
 *  Program uses JDBC to populate Choice component
 *  and then queries the database based upon the selection
 *
 */
public class OrdersGUI {
//
  public WindowListener 	windowListener;
  public ActionListener		exbtnListener;
  public ActionListener		btnListener;
  public ItemListener   	choiceListener;

  public Panel mainPanel;
  public Panel orderPanel;
  public Panel buttonPanel;
  public Button btnGetRow;
  public Button btnGetNextRow;
  public Button btnExit;

  public TextField txtCustID;
  //public TextField txtProdName;
  public Choice chProdName;

  public TextField txtCustName;
  public TextField txtAmount;
  public TextArea  txtMsg;
  public Label lblTitle;

  public Connection c = null;
  public Statement  s = null;
  public ResultSet rs = null;

  public OrdersGUI() {
	try {
	  // Load the Oracle JDBC driver
	  DriverManager.registerDriver(new oracle.jdbc.driver.OracleDriver());

	  Frame myFrame = new Frame("Sales Orders");
      mainPanel 	= new Panel();
      orderPanel	= new Panel();
      buttonPanel 	= new Panel();
      mainPanel.setBackground(Color.cyan);
      orderPanel.setBackground(Color.white);
      buttonPanel.setBackground(Color.white);

      btnGetRow 	= new Button("Get Customer Buying Product");
      btnGetNextRow = new Button("Get Next Customer Buying Product");
      btnExit 		= new Button("Exit");

	  exbtnListener 	= new ExBtnListener();
	  btnListener 		= new BtnListener();
	  windowListener 	= new WListener();

	  // Add listeners
	  myFrame.addWindowListener(windowListener);
	  btnExit.addActionListener(exbtnListener);
	  btnGetRow.addActionListener(btnListener);
	  btnGetNextRow.addActionListener(btnListener);


      lblTitle     	= new Label("Sales Orders by Product",Label.CENTER);
      lblTitle.setFont(new Font("Arial",Font.BOLD,16));
      txtCustID 	= new TextField(32);
  	  chProdName = new Choice();
      txtCustName   = new TextField(8);
      txtAmount     = new TextField(8);
      txtCustID.setBackground(Color.white);
      txtCustName.setBackground(Color.white);
      txtCustName.setEnabled(false);
      txtAmount.setBackground(Color.white);
      txtAmount.setEnabled(false);

      txtMsg      	= new TextArea(" ",4,10,TextArea.SCROLLBARS_NONE);
      txtMsg.setEditable(false);
      txtMsg.setText("Type a Customer ID, select a Product, and Push the button \nto begin listing jellybeans or 'Get Jellybean by Name' \n(you must enter name first)");
      txtMsg.setEnabled(false);
      mainPanel.setLayout(new GridLayout(4,1));
      orderPanel.setLayout(new GridLayout(4,2));
      buttonPanel.setLayout(new FlowLayout(FlowLayout.CENTER));
      mainPanel.add(lblTitle);

	  orderPanel.add(new Label("Cust ID"));
	  orderPanel.add(new Label("Product"));
      orderPanel.add(txtCustID);
      fillChoiceValues();
      orderPanel.add(chProdName);
	  orderPanel.add(new Label("Cust Name"));
	  orderPanel.add(new Label("Amount"));
      orderPanel.add(txtCustName);
      orderPanel.add(txtAmount);
      mainPanel.add(orderPanel);

      buttonPanel.add(btnGetRow);
      buttonPanel.add(btnGetNextRow);
      buttonPanel.add(btnExit);
      mainPanel.add(buttonPanel);

      mainPanel.add(txtMsg);
      myFrame.add(mainPanel);
      myFrame.setSize(500,380);
      myFrame.show();
      } // end try block
      catch (Exception e) {
         System.out.println(e);
         System.out.println("Boom!");
      } // end catch block
    } // end OrdersGUI constructor

    /** Inner class ExBtnListener */
	public class ExBtnListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			System.exit(0);
		} // end actionPerformed
	} // end ExBtnListener

    /** Inner class BtnListener */
	public class BtnListener implements ActionListener {
		public void actionPerformed(ActionEvent e) {
			if (e.getActionCommand().equals("Get Customer Buying Product"))
			{
				getRecord(txtCustID.getText(),chProdName.getSelectedItem());
			}
			else if (e.getActionCommand().equals("Get Next Customer Buying Product"))
			{
				getNextRecord(txtCustID.getText(),chProdName.getSelectedItem());
				//txtMsg.setText("Pushed Get Next Customer");
			}
		} // end actionPerformed
	} // end BtnListener

 public class ChoiceListener implements ItemListener {
	public void itemStateChanged(ItemEvent e) {
 			productChoiceChanged(chProdName.getSelectedItem());
 	}
 } // end ChoiceListener

    /** Inner class WListener */
	public class WListener implements WindowListener {
		public void windowClosing(WindowEvent e) {
			System.exit(0);
		}
		public void windowOpened(WindowEvent e) {
		}
		public void windowClosed(WindowEvent e) {
		}
		public void windowDeactivated(WindowEvent e) {
        }
		public void windowDeiconified(WindowEvent e) {
		}
		public void windowIconified(WindowEvent e) {
		}
		public void windowActivated(WindowEvent e) {
		}
	} // end WBtnListener

   public static void main(String[] args) {
	 OrdersGUI myJB = new OrdersGUI();
   } // end init

	public void fillChoiceValues() {

	  Connection conn = null;
	  Statement  stmt = null;
	  ResultSet  rset = null;
	  try {
	      // Connect to the database, connection string format:
	      // Please do not hard code userid/password in real programs!
	      conn =
	        DriverManager.getConnection ("jdbc:oracle:thin:@tecra:1521:tec817",
					   "scott", "tiger");
	      // Create a Statement
	      stmt = conn.createStatement ();
	  	  String mySql = "select descrip from product"
		               + " order by descrip";
	      rset = stmt.executeQuery(mySql);
		  while (rset.next ()) {
			  chProdName.add(rset.getString("DESCRIP"));
		  }
	  } // end try
	  catch (SQLException e) {
		  txtMsg.setText("Problem reading PRODUCT table");
		  e.printStackTrace();
		  System.exit(0);
	  }
	  catch (Exception e) {
		  txtMsg.setText("Some other problem, good-bye!");
		  System.exit(0);
	  }
	  finally {
		  try {
		   	// Close statement
			stmt.close();
			// Close connection
			conn.close();
		  }
		  catch (SQLException e) {
			txtMsg.setText("Problem closing PRODUCT table statement");
			e.printStackTrace();
		  }
	  }
	} // fill choice values

    public void getRecord(String inCustID, String inProdName) {
	  Connection conn = null;
	  Statement  stmt = null;
	  ResultSet  rset = null;
	  try {
	      // Connect to the database, connection string format:
	      conn =
	        DriverManager.getConnection ("jdbc:oracle:thin:@tecra:1521:tec817",
					   "scott", "tiger");
	      // Create a Statement
	      stmt = conn.createStatement ();
	  	  String mySql = "select custname,amount from sales"
		             + " where custid = '" + inCustID + "' "
		             + "   and prodname = " + "'" + inProdName + "'"
		             + " order by amount desc";
	      rset = stmt.executeQuery(mySql);
		  if (rset.next ()) {
	      	  txtCustName.setText(rset.getString("CUSTNAME"));
	    	  txtAmount.setText(String.valueOf(rset.getDouble("AMOUNT")));
	    	  txtMsg.setText("Record " + inCustID + " found");
		  }
	      else {
	    	  txtCustName.setText(" ");
	    	  txtAmount.setText(" ");
	    	  txtMsg.setText("Record " + inCustID + " not found");
		  }
	  } // end try
	  catch (SQLException e) {
		  txtMsg.setText("Problem reading database");
		  e.printStackTrace();
	  }
	  catch (Exception e) {
		  txtMsg.setText("Some other problem, good-bye!");
		  System.exit(0);
	  }
	  finally {
		  try {
		   	// Close statement
			stmt.close();
			// Close connection
			conn.close();
		  }
		  catch (SQLException e) {
			txtMsg.setText("Problem closing SQL statement");
			e.printStackTrace();
		  }
	  }
    } // end getRecord


    public void getNextRecord(String inCustID, String inProdName) {
	  Connection conn = null;
	  Statement  stmt = null;
	  ResultSet  rset = null;
	  try {
	      // Connect to the database, connection string format:
	      conn =
	        DriverManager.getConnection ("jdbc:oracle:thin:@tecra:1521:tec817",
					   "scott", "tiger");
	      // Create a Statement
	      stmt = conn.createStatement ();
	  	  String mySql = "select custid,custname,amount from sales"
		             + " where custid > '" + inCustID + "' "
		             + "   and prodname = " + "'" + inProdName + "'"
		             + " order by amount desc";
	      rset = stmt.executeQuery(mySql);
		  if (rset.next ()) {
			  txtCustID.setText(String.valueOf(rset.getInt("CUSTID")));
	      	  txtCustName.setText(rset.getString("CUSTNAME"));
	    	  txtAmount.setText(String.valueOf(rset.getDouble("AMOUNT")));
	    	  txtMsg.setText("Record " + txtCustID.getText() + " found");
		  }
	      else {
	    	  txtCustName.setText(" ");
	    	  txtAmount.setText(" ");
	    	  txtMsg.setText("Record beyond " + inCustID + " not found");
		  }
	  } // end try
	  catch (SQLException e) {
		  txtMsg.setText("Problem reading database");
		  e.printStackTrace();
	  }
	  catch (Exception e) {
		  txtMsg.setText("Some other problem, good-bye!");
		  System.exit(0);
	  }
	  finally {
		  try {
		   	// Close statement
			stmt.close();
			// Close connection
			conn.close();
		  }
		  catch (SQLException e) {
			txtMsg.setText("Problem closing SQL statement");
			e.printStackTrace();
		  }
	  }
    } // end getNextRecord

    public void clearValues() {
      txtCustName.setText(" ");
      txtAmount.setText(" ");
    } // end clearValues

	public void productChoiceChanged(String newValue) {
		System.out.println("Product changed to " + newValue);
	}
} // end OrdersGUI